///////////////////////////////////////////////////////////////////////////
// copyleft 2008
// This file is part of FileUploader addon for Brazil Firewall.
//
// FileUploader is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3, or (at your option)
// any later version.
//
// FileUploader is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// www.gnu.org
//
// Daniel Torres (Cavernicola)
// Mexicali, Baja California, Mexico, Junio 2008
// thecavernicola@gmail.com
//////////////////////////////////////////////////////////////////////////

#include "filetoupload.h"
#include <iostream>

FileToUpload::FileToUpload()
{
    BufferSize = 0;
}

FileToUpload::~FileToUpload()
{
    //dtor
}

bool FileToUpload::SetPathDeDestino(string lineBuffer)
{
    //name="PathToUpload" /path/to/upload ---------------------
    //--------4676463917806168691151430513 Content-Disposition: form-data

    lineBuffer.erase(0, 1); // limpiamos nulos

    int beg = sizeof("name=\"PathToUpload\"");
    int end = lineBuffer.find("--");

    PathToUpload = lineBuffer.substr( beg, end - beg );

    PathToUpload.erase(0, 3);// limpiamos nulos
    PathToUpload.erase(PathToUpload.size()-2, 2);// limpiamos nulos

    if(PathToUpload[0] != '/')
    {
        PathToUpload == "";
        return false;
    }
    if(PathToUpload[PathToUpload.size()-1] != '/')
        PathToUpload.insert(PathToUpload.size(),  "/");

    return true;
}

bool FileToUpload::DeterminarAlgunchmod(string buffer)
{
    if ( buffer.find("setR") != string::npos )
    {
        r = true;
        return true;
    }
    else if ( buffer.find("setW") != string::npos )
    {
        w = true;
        return true;
    }
    else if ( buffer.find("setX") != string::npos )
    {
        x = true;
        return true;
    }

    return false;
}

void FileToUpload::SetChmod(string &buffer)
{
    while ( DeterminarAlgunchmod( buffer  ) )
    {
        getline( cin, buffer, ';' ); //El contenido de esta linea es variable y depende de si se selecciono algun chmod.
        BufferSize -= buffer.size();
    }

}

string FileToUpload::GetPathToUpload()
{
    return PathToUpload;
}

bool FileToUpload::GeteXecute()
{
    return x;
}

bool FileToUpload::GetWrite()
{
    return w;
}

bool FileToUpload::GetRead()
{
    return r;
}

string FileToUpload::GetURLToDownload()
{
    return URLToDownload;
}

string FileToUpload::GetUrlFileName()
{
    return UrlFileName;
}

void FileToUpload::SetURLToDownload(string LineBuffer)
{
//name="HttpFileToUpload" http://x.x.x/file.xxx --------------------
// ---------407363726210614241373833191 Content-Disposition: form-data
    DownloadFromINET = false;

    LineBuffer.erase(0, 1); //Eliminamos nulo

    int beg = sizeof("name=\"HttpFileToUpload\"");

    int end = LineBuffer.find("--");

    URLToDownload = LineBuffer.substr(beg, end - beg); // Extraemos el URL

    URLToDownload.erase(0, 3); //Limpiamos nulos

    URLToDownload.erase(URLToDownload.size() - 2, 2); //Limpiamos nulos
	
    if( URLToDownload.size() > 0 )
        DownloadFromINET = true;
    else
    {
        DownloadFromINET = false; // No se escribio nada en el cuadro URL
        return;
    }

    if ( URLToDownload[0] != 'h' && URLToDownload[0] != 'H' && URLToDownload[0] != 'f' && URLToDownload[0] != 'F')
    {
        URLToDownload = "";
        //DownloadFromINET = true; // Es true para que el usuario sepa que escribio mal la direccion
        return;// No es un URL valido ftp o http
    }

    //http://x.x.x/file.xxx;
    // Extraemos el nombre del archivo de el URL
    beg = URLToDownload.rfind('/', URLToDownload.size());
    end = URLToDownload.size();
    UrlFileName =  URLToDownload.substr(beg+1, end - beg); // Extraemos el filename
    
    if(UrlFileName == "")
	URLToDownload = "";
}

void FileToUpload::SetLocalFileName(string LineBuffer)
{//filename="ACDC - I Love Rock and Roll.mp3" Content-Type: audio/mpeg
    LineBuffer.erase(0, 1);

    LineBuffer.erase(LineBuffer.size()-1, 1);

    int beg = LineBuffer.find('"') + 1;

    int end = LineBuffer.rfind('"', LineBuffer.size());

    LocalFileName = LineBuffer.substr(beg, end - beg); // Extraemos el nombre del archivo.
}

string FileToUpload::GetLocalFileName()
{
    return LocalFileName;
}

bool FileToUpload::IsDownloadFromINET()
{
    return DownloadFromINET;
}

