///////////////////////////////////////////////////////////////////////////
// copyleft 2008
// This file is part of FileUploader addon for Brazil Firewall.
//
// FileUploader is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3, or (at your option)
// any later version.
//
// FileUploader is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// www.gnu.org
//
// Daniel Torres (Cavernicola)
// Mexicali, Baja California, Mexico, Junio 2008
// thecavernicola@gmail.com
//////////////////////////////////////////////////////////////////////////


#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <dirent.h>
#include "filetoupload.h"

using namespace std;

/// CONSTANTES
const char* SCRIPT = "fileuploader.cgi";
const char* COYOTE_CONF = "/etc/coyote/coyote.conf";
const char* EXEC_WF = "/var/http/execWF.sh";
string UPLOAD_PATH = "";

///VARIABLES
string Lenguaje = "'ENU'"; // 'ESP', 'BRZ'


void cl_footer2()
{
  struct stat stFileInfo;

  cout << "</td></tr></table></td></tr></table>"
       << ( stat( "/tmp/need.save" ,&stFileInfo) == 0 ? "<br><center><div id=warning>WARNING: Configuration has been changed but not yet backed up.</div></center>" : "")
       << ( stat( "/tmp/need.reboot" ,&stFileInfo) == 0 ? "<br><center><div id=warning>WARNING: Configuration has been backed up but system not yet rebooted.</div></center>" : "");
       //Wta="WARNING: Configuration has been changed but not yet backed up."
       //Wtb="WARNING: Configuration has been backed up but system not yet rebooted."*/LANGUAGE_CODE="ESP"

}

void cl_header2()
{
    string s = " cl_header2 FileUploader";
    s.insert(0, EXEC_WF);
    system(s.c_str());
}

void show( string s )
{
    cl_header2();
    cout << s;
    cl_footer2();
    exit(0);
}

void InitVariables()
{
    ifstream file ( COYOTE_CONF, ifstream::in);
    string line = "";
    uint index1 = 0;

    while(!file.eof())
    {
        getline(file, line);

        index1 = line.find("LANGUAGE_WEBADMIN=");

        if(index1 != string::npos)
        {
            line = line.substr( index1 + (sizeof("LANGUAGE_WEBADMIN=") - 1));
            Lenguaje = line;
            continue;
       }
    }
	//show(Lenguaje);

    file.close();
}

const char* MensajeSubidaExitosa( const char* filename, int size )
{
    if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 )
        cout << "Archivo <b>" << filename << "</b> cargado correctamente, <b>" << size << "</b> bytes cargados. " << endl;

    else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 )
        cout << "Arquivo <b>" << filename << "</b> enviado com sucesso, <b>" << size << "</b> bytes enviados." << endl;

    else cout << "File <b>" << filename << "</b> uploaded successfully, <b>" << size << "</b> bytes uploaded." << endl;

    return "Upload";
}

const char* ShowMSG( uint code )
{
    switch( code )
    {
        case 1: // Select file to upload
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Escriba la URL del archivo que desea subir.<br /><br />O<br /><br />Seleccione el archivo a subir.";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "Digite o URL do arquivo que você deseja enviar.<br /><br />O<br /><br />Selecione o arquivo a ser enviado.";

            return "Type the URL of the file that you wish to upload<br /><br />Or<br /><br />Select the file to upload.";

            break;
        }
        case 2: // Button Upload
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Enviar";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "Enviar";

            return "Upload";

            break;
        }
        case 3: // Path de destino
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) show("Error, la direccion de la carpeta donde se depositara el archivo debe ser absoluta desde el directorio raiz \" / \", como, \"/uploads\".");
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) show("Erro, o atalho para a pasta aonde se encontra o arquivo para ser enviado, deve estar exatamante na pasta raiz \"/ \", exemplo, \"/enviados\".");
                    else show("Error, the path to the folder where the file will be uploaded, must be absolute with the root folder \" / \", like, \" /uploads \".");

            break;
        }
        case 4:
        {
            cl_header2();

            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) cout << "Error, debe seleccionar un archivo para subir.";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) cout << "Erro, você precisa selecionar o arquivo a ser enviado";
                    else cout << "Error, you must select a file to upload.";

            cl_footer2();
		break;
        }
        case 5:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Direccion donde sera cargado el archivo.<br />La carpeta sera creada o montada automaticamente";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "Pasta onde o arquivo será carregado. O diretório será criado automaticamente ou montado";

            return "Path where the file will be uploaded.<br />The directory will be created or mounted automatically";
	    break;
        }
        case 6:
        {
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) return "Seleccione un permiso para establecer al archivo.";
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) return "Selecione permissões para atribuir ao arquivo.";

            return "Select a file permission to set with chmod.";
	    break;
        }
        case 7:
        {
          //  cl_header2();

            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) show("Archivo enviado correctamente");
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) show("Arquivo enviado corretamente");
                    else show("File uploaded successfully");

		break;
            //cl_footer2();

        }
       case 8:
        {//Direcciones incorrectas
            if( memcmp( "'ESP'", Lenguaje.c_str(), 5 ) == 0 ) show("Error al enviar el archivo, verifique que las direcciones sean correctas.");
                else if( memcmp( "'BRZ'", Lenguaje.c_str(), 5 ) == 0 ) show("Erro ao enviar o arquivo, verificar se os endereços estão corretos.");
                    else show("Error while uploading the file, check the file paths");
            break;
        }

    }

    return "";
}

bool mntIsMounted()
{
    ifstream file ( "/proc/mounts", ios::binary);
    string line = "";

    while(!file.eof())
    {
        getline(file, line);

        if( line.find( "/dev/boot /mnt" ) != string::npos )
        	return true;

    }
    file.close();

    return false;
}

void CheckFolderToUpload( string folder )
{
     if( folder == "/mnt/" )
     {
         if( ! mntIsMounted() )
            system("mount /dev/boot /mnt -t vfat");

         return;
     }

      struct stat stFileInfo;

      if(stat( folder.c_str() ,&stFileInfo) == -1)
      {
          folder.insert(0, "mkdir -p ");

          system(folder.c_str());
      }
}

void ParseBuffer( FileToUpload* file )
{
    file->BufferSize = atoi(getenv("CONTENT_LENGTH"));

    string buffer;

    int Index = 1;
    char del = ';';
    while( Index < 8 )
    {
        getline( cin, buffer, del );
        file->BufferSize -= buffer.size();

        switch( Index )
        {
            //case 1://-----------------------------4676463917806168691151430513 Content-Disposition: form-data
            case 2://name="PathToUpload" /path/to/upload -----------------------------4676463917806168691151430513 Content-Disposition: form-data
            {
                if(! file->SetPathDeDestino( buffer ) )
                {
                    ShowMSG(3); // Mostramos error y salimos.
                }
                break;
            }
            case 3://El contenido de esta linea es variable y depende de si se selecciono algun chmod.
            {
                file->SetChmod( buffer );

                file->SetURLToDownload( buffer );

                break;
            }
            case 4://name="FileToUpload"
            {
                del = '\n';
                break;
            }
            case 5: //filename="ACDC - I Love Rock and Roll.mp3" Content-Type: audio/mpeg
            {
                file->SetLocalFileName(buffer);

                break;
            }
            //case 6: //Content-Type: audio/mpeg
            case 7: //Blank,
            {
                break;
            }
        }
        Index++;
    }
    //LLegamos al primer byte del archivo a subir
}

void UnmountMnt()
{
    if( mntIsMounted() )
        system("umount /mnt");
}

void ApplyChmod(FileToUpload file)
{
    string filename;
    if( file.IsDownloadFromINET() )
        filename = file.GetUrlFileName();
    else
        filename = file.GetLocalFileName();

    filename = filename.insert(0, file.GetPathToUpload());

    string mode;

    if( file.GetRead() == true )
    {
        mode = "chmod +r " + filename;
        system(mode.c_str());
    }
    else
    {
        mode = "chmod -r " + filename;
        system(mode.c_str());
    }
    
    if( file.GetWrite() == true )
    {
        mode = "chmod +w " + filename;
        system(mode.c_str());
    }
    else
    {
        mode = "chmod -w " + filename;
        system(mode.c_str());
    }

    if( file.GeteXecute() == true )
    {
        mode = "chmod +x " + filename;
        system(mode.c_str());
    }
    else
    {
        mode = "chmod -x " + filename;
        system(mode.c_str());
    }

}

void DownloadFromWebAdnExit(FileToUpload file)
{
    if( file.GetURLToDownload() == "" )
        ShowMSG(8); //La direccion era incorrecta

    //Verificamos la carpeta donde sera subido el archivo
    CheckFolderToUpload( file.GetPathToUpload() );

    //wget -O /path/to/upload/url.file.name url.to.download
    string command = "wget -O " + file.GetPathToUpload() + file.GetUrlFileName() + " " + file.GetURLToDownload();

    system(command.c_str());

    struct stat stFileInfo;

    command = file.GetPathToUpload() + file.GetUrlFileName();

    if( stat( command.c_str(), &stFileInfo) == 0 )
    {
        ApplyChmod(file);
        UnmountMnt();
        ShowMSG(7);
    }
    else
    {
        ShowMSG(8);
    }
}

void UploadLocalFileAndExit(FileToUpload file)
{
    string filename = file.GetPathToUpload() + file.GetLocalFileName();
    if(file.GetLocalFileName() == "")
	return;

    //Verificamos la carpeta donde sera subido el archivo
    CheckFolderToUpload( file.GetPathToUpload() );

    ofstream oFile(filename.c_str(), ios::out | ios::binary);

    if( oFile.is_open() )
    {
        char *buffer = new char[file.BufferSize];

        cin.read(buffer, file.BufferSize);

        int secure = file.BufferSize - 182;// Zona de seguridad para comenzar el monitoreo de final del archivo.
        int i;
        for( i=0; i <file.BufferSize; i++ )// Copiamos byte por byte el archivo para poder monitorear el final del archivo.
        {
            if( secure > i && buffer[i+1] == '\n' && buffer[i+2] == '-' && buffer[i+3] == '-') // Si el siguiente byte al actual es \n y
            {                                                                                  // el que sigue es - y el que sigue es -
                break;                                                                         // hemos llegado al final del archivo.
            }
            oFile.write(&buffer[i], 1);  //POSIBLE BUG, este byte despues de haber determinado el final
        }                                                          // del archivo debe o no debe ser copiado?, parece que no.

        delete buffer; //Borramos el buffer para evitar memory leaks.

	oFile.close();

        ApplyChmod(file);
	
	cl_header2();
        MensajeSubidaExitosa(file.GetLocalFileName().c_str(), i);
	cl_footer2();

        UnmountMnt();

	exit(0);
    }
    else
    {
        UnmountMnt();

        show("Error, the file could not be created at the server or could not be opened");
   }
}

void Upload()
{
    FileToUpload file;

    ParseBuffer( &file );

    //El archivo web tiene prioridad sobre el Local, si es web lo descargamos y salimos(se sale
    //desde la funcion de descarga.
    if( file.IsDownloadFromINET() )
          DownloadFromWebAdnExit(file);

    //Si no fue archivo web, subimos el local
    UploadLocalFileAndExit(file);
}

int main()
{
    InitVariables();

    char* rqmt = getenv("REQUEST_METHOD");

    if( rqmt == NULL) return 0;

    if(memcmp( "POST", rqmt, 4) == 0)
    {
        Upload();
        return 0;
    }
    else if(memcmp( "GET", rqmt,3 ) == 0)
    {
        cl_header2();
        cout << "<form action=" << SCRIPT << " method=\"post\" enctype=\"multipart/form-data\">"
	    <<     "<table class=maintable width=100% border=\"0\">"
            <<         "<tr><th colspan=\"2\">File uploader</th></tr>"
            <<         "<tr>"
            <<             "<td class=row6><b>" << ShowMSG(5) << "</td>"
            <<             "<td class= row2><br /><input name=\"PathToUpload\" /><br /><br /></td>"
            <<         "</tr>"
            <<         "<tr>"
            <<             "<td class=row6><b>" << ShowMSG(6) << "</td>"
            <<             "<td class= row2><br />"
            <<                  "<input name=\"moder\" value=\"setR\" type=\"checkbox\" />r&nbsp;"
            <<                  "<input name=\"modew\" value=\"setW\" type=\"checkbox\" />w&nbsp;"
            <<                  "<input name=\"modex\" value=\"setX\" type=\"checkbox\" />x"
            <<                  "<br /><br />"
            <<             "</td>"
            <<         "</tr>"
            <<         "<tr>"
            <<             "<td class=row6><b>" << ShowMSG(1) << "</td>"
            <<             "<td class= row2><br /><input name=\"HttpFileToUpload\" /><br /><br />"
            <<             "<input name=\"FileToUpload\" type=\"file\" /><br /><br /></td>"
            <<         "</tr>"
            <<         "<tr>"
            <<             "<td class=row2 colspan=2 align=center><input name=\"UploadIt\" value=\"" << ShowMSG(2) << "\" type=\"submit\" /></td>"
            <<         "</tr>"
            <<     "</table>"
            << "</form>"
            << endl;
        cl_footer2();
    }
}
